using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
namespace ChessEngine
{
    class Chess
    {
        public int[] start = {6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,
                               6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,
                               6 ,6 ,2 ,4 ,3 ,0 ,1 ,3 ,4 ,2 ,6 ,6 ,
                               6 ,6 ,5 ,5 ,5 ,5 ,5 ,5 ,5 ,5 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,13,13,13,13,13,13,13,13,6 ,6 ,
                               6 ,6 ,10,12,11,8 ,9 ,11,12,10,6 ,6 ,
                               6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,
                               6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 };
        public int[] F_rating = {200, 9,5,3,3,1};

        public int[] move_arround = { 1, 13, 12, 11, -1, -13, -12, -11 };       //King
        public int[] move_knight =  { -25, -23, -10, 14, 25, 23, 10, -14 };

        public BestMoves bestmoves;

        public int[] field;

        public Chess()
        {
            field = start;
            mov = new List<Move>();
            e = new Engine();
            bestmoves = new BestMoves();
        }

        public Move[] GetMoves(int movecolor)
        {
            List<Move> moves = new List<Move>();
            int x, y, z, wide, value, figure, target, color, feld;
            y = 7;
            do
            {
                x = 7;
                do
                {
                    color = 1;
                    feld = 26 + x + 12 * y; //Alle begebaren Felder durchgehen
                    if (field[feld] != 7)              //Ist das Feld auch nicht leer?
                    {
                        if ((figure = field[feld]) > 7)
                        {
                            color = -1;
                            figure -= 8;
                        }
                        if (color == movecolor)
                            switch (figure)
                            {
                                case 0: //King
                                    z = 7;
                                    do
                                    {
                                        if ((value = field[target = feld + move_arround[z]]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                                moves.Add(new Move(feld, target));

                                    }
                                    while (z-- != 0);
                                    break;
                                case 1:
                                    z = 7;
                                    do
                                    {
                                        wide = 0;
                                        while ((value = field[target = feld + move_arround[z] * ++wide]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                            {
                                                moves.Add(new Move(feld, target));
                                                break;
                                            }
                                            else
                                                break;
                                    }
                                    while (z-- != 0);
                                    break;
                                case 2:
                                    z = 8;
                                    do
                                    {
                                        z -= 2;
                                        wide = 0;
                                        while ((value = field[target = feld + move_arround[z] * ++wide]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                            {
                                                moves.Add(new Move(feld, target));
                                                break;
                                            }
                                            else
                                                break;
                                    }
                                    while (z != 0);
                                    break;
                                case 3:
                                    z = 9;
                                    do
                                    {
                                        z -= 2;
                                        wide = 0;
                                        while ((value = field[target = feld + move_arround[z] * ++wide]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                            {
                                                moves.Add(new Move(feld, target));
                                                break;
                                            }
                                            else
                                                break;
                                    }
                                    while (z != 1);
                                    break;
                                case 4:
                                    z = 7;
                                    do
                                    {
                                        if ((value = field[target = feld + move_knight[z]]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                                moves.Add(new Move(feld, target));
                                    }
                                    while (z-- != 0);
                                    break;
                                case 5:
                                    if ((value = field[target = feld + 12 * color]) == 7)
                                    {
                                        moves.Add(new Move(feld, target));
                                        if(y == 1 || y == 6)
                                            if ((value = field[target = feld + 24 * color]) == 7)
                                            moves.Add(new Move(feld, target));
                                    }
                                    if ((value = field[target = feld + 11 * color]) != 6 && value != 7 && (value > 7 && color == 1 || value < 6 && color == -1))
                                        moves.Add(new Move(feld, target));
                                    if ((value = field[target = feld + 13 * color]) != 6 && value != 7 && (value > 7 && color == 1 || value < 6 && color == -1))
                                        moves.Add(new Move(feld, target));
                                    break;
                                default: throw new Exception();
                            }
                    }
                }
                while (x-- != 0);
            }
            while (y-- != 0);
            return moves.ToArray();
        }

        public void DoMove(Move m)
        {
            field[m.To] = field[m.From];
            field[m.From] = 7;
        }

        public Move AB(int color, int depth)
        {
            mov.Clear();
            e.treeView1.Nodes.Clear();
            bestmoves.listView1.Items.Clear();
            ts = new TreeSave(new Move(0,0));
            maxdepth = 4;
            int wert;
            if (color == 1)
                wert = Max(color, -1000, 1000, 0, ref ts);
            else
                wert = Min(color, 1000, -1000, 0, ref ts);
            Console.WriteLine("Zug Wertung: " + Max(color, -1000, 1000, 0, ref ts));
            e.treeView1.Nodes.AddRange(getNode(ts));
            mov.Sort();
            for(int i = 0; i!= mov.Count; i++)
                bestmoves.listView1.Items.Add(new ListViewItem(new string[]{mov[i].ToPlayer(),mov[i].ToMove(),mov[i].Rating.ToString()}));
            return mov[0];
        }


        public TreeNode[] getNode(TreeSave t)
        {
            if (t == null)
                return new TreeNode[] { new TreeNode("Nothing") };
            if (t.ts == null)
                return new TreeNode[] { new TreeNode(t.m.ToString()) };
            List<TreeNode> tn = new List<TreeNode>();
            for (int i2 = 0; i2 < t.ts.Length; i2++)
            {
                if (t.ts[i2] == null)
                    break;
                tn.Add(new TreeNode(t.ts[i2].m.ToString(), getNode(t.ts[i2])));
            }
            return tn.ToArray();
        }
        int maxdepth = 4;

        int Min(int color, int alpha, int beta, int depth, ref TreeSave t)
        {
            if (depth == maxdepth)
                return Rate();
            Move[] moves = GetMoves(color);
            t.ts = new TreeSave[moves.Length];
            for (int i = 0; i != moves.Length; i++)
            {
                t.ts[i] = new TreeSave(moves[i]);
                int oldTo = field[moves[i].To];
                field[moves[i].To] = field[moves[i].From];
                field[moves[i].From] = 7;
                int wert = Max(color * -1, alpha, beta, depth + 1, ref t.ts[i]);
                t.ts[i].m = new Move(moves[i], wert, depth + 1);
                if (depth == 0)
                    mov.Add(new Move(moves[i], wert, depth + 1));
                //Rckgngigmachen:
                field[moves[i].From] = field[moves[i].To];
                field[moves[i].To] = oldTo;
                if (wert <= alpha)
                   return alpha;
                if (wert < beta)
                    beta = wert;
            }

            return beta;
        }

        public List<Move> mov;

        public Engine e;
        TreeSave ts;

        int Max(int color, int alpha, int beta, int depth, ref TreeSave t)
        {
            if (depth == maxdepth)
                return Rate();
            Move[] moves = GetMoves(color);
            t.ts = new TreeSave[moves.Length];
            for (int i = 0; i != moves.Length; i++)
            {
                t.ts[i] = new TreeSave(moves[i]);
                int oldTo = field[moves[i].To];
                field[moves[i].To] = field[moves[i].From];
                field[moves[i].From] = 7;
                int wert = Min(color * -1, alpha, beta, depth + 1, ref t.ts[i]);
                t.ts[i].m = new Move(moves[i], wert, depth + 1);
                if (depth == 0)
                    mov.Add(new Move(moves[i], wert, depth + 1));
                //Rckgngigmachen:
                field[moves[i].From] = field[moves[i].To];
                field[moves[i].To] = oldTo;
                if (wert >= beta)
                    return beta;
                if (wert > alpha)
                    alpha = wert;

            }
            return alpha;
        }

        public int Rate(Move m)
        {
            int oldTo = field[m.To];
            field[m.To] = field[m.From];
            field[m.From] = 7;
            //Jetzt rechnen wir ab:
            int rating = 0, value, x, y; //rating muss int16 sein!!!
            //Erst mal die Figurenwerte
            y = 7;
            do
            {
                x = 7;
                do
                {
                    int feld = 26 + x + 12 * y;
                    if ((value = field[feld]) < 6)
                        rating += F_rating[value] * 10;
                    else if (value > 7)
                        rating -= F_rating[value - 8] * 10;
                }
                while (x-- != 0);
            }
            while (y-- != 0);
            //jetzt die Beweglichkeit:
            rating += GetMoves(1).Length;
            rating -= GetMoves(-1).Length;
            //Rckgngigmachen:
            field[m.From] = field[m.To];
            field[m.To] = oldTo;
            return rating;
        }
        public int Rate()
        {
            //Jetzt rechnen wir ab:
            int rating = 0, value, x, y; //rating muss int16 sein!!!
            //Erst mal die Figurenwerte
            y = 7;
            do
            {
                x = 7;
                do
                {
                    int feld = 26 + x + 12 * y;
                    if ((value = field[feld]) < 6)
                        rating += F_rating[value] * 10;
                    else if (value > 7)
                        rating -= F_rating[value - 8] * 10;
                }
                while (x-- != 0);
            }
            while (y-- != 0);
            //jetzt die Beweglichkeit:
            rating += GetMoves(1).Length;
            rating -= GetMoves(-1).Length;
            return rating;
        }
    }

    public class Move : IComparable
    {
        int from, to, rating;
        public Move prev;
        public int count, move;
        public Move(int from, int to)
        {
            count = 0;
            this.from = from;
            this.to = to;
            rating = 0;
            prev = null;
        }


        public Move(Move m, int rating)
        {
            move = 1;
            from = m.from;
            to = m.to;
            this.rating = rating;
        }

        public Move(Move m, int rating ,int move)
        {
            this.move = move;
            from = m.from;
            to = m.to;
            this.rating = rating;
        }

        string abc = "HGFEDCBA";

        public override string ToString()
        {
            if (from == to && to == 0)
                return "URNODE";
            return  ToPlayer() + " " + ToMove() + " [" + (float)rating / 10 + "]";
        }

        public string ToMove()
        {
            return abc[from % 12 - 2].ToString() + (from / 12 - 1) + " - " + abc[to % 12 - 2].ToString() + (to / 12 - 1);
        }

        public string ToPlayer()
        {
            return ((move % 2) == 1 ? (move / 2 + ".") : (move / 2 + ". ..."));
        }

        public bool IsEqual(Move m)
        {
            if (m.to == to && m.from == from)
                return true;
            return false;
        }

        public int From
        {
            get
            {
                return from;
            }
            set
            {
                from = value;
            }
        }
        public int To
        {
            get
            {
                return to;
            }
            set
            {
                to = value;
            }
        }

        public int Rating
        {
            get
            {
                return rating;
            }
            set
            {
                rating = value;
            }
        }

        public int CompareTo(object obj)
        {
            return ((Move)obj).rating.CompareTo(rating);
        }
    }

    public enum Figure
    {
        W_King = 0, W_Queen = 1, W_Rook = 2,  W_Bishop = 3,  W_NKnight = 4,  W_Pawn = 5,
        B_King = 8, B_Queen = 9, B_Rook = 10, B_Bishop = 11, B_NKnight = 12, B_Pawn = 13, 
        
        OutOfField = 6,  Empty = 7,
    }

    class TreeSave
    {
        public TreeSave[] ts;
        public Move m;
        public TreeSave(Move m)
        {
            this.m = m;
        }
    }
}
