using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;


namespace ChessEngine
{
    public partial class Form1 : Form
    {
        
        Bitmap[] b;
        Chess c;
        ImageAttributes ia;
        public Form1()
        {
            InitializeComponent();
            b = new Bitmap[6];
            b[0] = Properties.Resources._0;
            b[1] = Properties.Resources._1;
            b[2] = Properties.Resources._2;
            b[3] = Properties.Resources._3;
            b[4] = Properties.Resources._4;
            b[5] = Properties.Resources._5;
            c = new Chess();
            ia = new ImageAttributes();
            ColorMatrix cm = new ColorMatrix();

            cm.Matrix00 = cm.Matrix11 = cm.Matrix22 = -1;
            cm.Matrix40 = cm.Matrix41 = cm.Matrix42 = 1;

            ia.SetColorMatrix(cm);


        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tmp = new Move(0, 0);
            c.e.Show();
            c.bestmoves.Show();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            for (int x = 0; x != 8; x++)
                for (int y = 0; y != 8; y++)
                {

                    int feld = c.field[26 + x + 12 * y];
                    if ((x + y) % 2 == 0)
                        e.Graphics.FillRectangle(new SolidBrush(Color.LightGray), new Rectangle(x * 44, y * 44, 44, 44));
                    else
                        e.Graphics.FillRectangle(new SolidBrush(Color.DarkGray), new Rectangle(x * 44, y * 44, 44, 44));
                    if(feld == 7)
                        continue;
                    if (feld > 7)
                    {
                        e.Graphics.DrawImage(b[feld - 8], x * 44, y * 44);
                    }
                    else
                        e.Graphics.DrawImage(b[feld],new Rectangle(x * 44, y * 44,44,44),0,0,44,44,GraphicsUnit.Pixel,ia);
                }

        }

        int move = 1;

        private void button1_Click(object sender, EventArgs e)
        {
            //c.bestM = null;
            //Console.WriteLine(c.BestMove3(move, 0,5, -5));
            //Move m = c.BestMove(move,0,3);
            //Move m = c.DoMove4(move, 10);

            Move m = c.AB(move, 4);
            c.DoMove(m);
            Console.WriteLine(m.ToString());
            move *= -1;
            Refresh();
        }

        Move tmp;
        int step;

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            step = 0;
            if (e.X < 44 * 8 && e.Y < 44 * 8)
            {
                tmp.From = 26 + e.X / 44 + e.Y / 44 * 12;
                step = 1;
            }
        }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            if (step == 1)
            {
                tmp.To = 26 + e.X / 44 + e.Y / 44 * 12;
                Move[] temp = c.GetMoves(move);
                for (int i = 0; i != temp.Length; i++)
                    if (temp[i].IsEqual(tmp))
                    {
                        c.DoMove(tmp);
                        Console.WriteLine(":" + tmp.ToString() + " [" + c.Rate().ToString() + "]");
                        move *= -1;
                        Refresh();
                        if (checkBox1.Checked)
                            button1_Click(null, null);
                    }
            }
            step = 0;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

    }
}